=== ext/native/gfx/CMakeLists.txt ===
set(SRCS
  gl_debug_log.cpp
  gl_lost_manager.cpp
  texture_atlas.cpp)

set(SRCS ${SRCS})

add_library(gfx STATIC ${SRCS})

if(UNIX)
  add_definitions(-fPIC)
endif(UNIX)
