=== debian/changelog ===
ppsspp (1.8.0-0.1~mx17+1) mx; urgency=medium

  * New upstream release.
  * Build against system ffmpeg.
  * Add libavdevice-dev to build-deps.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 27 Apr 2019 11:27:23 -0700

ppsspp (1.7.4-0.1~mx17+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 27 Nov 2018 17:56:16 -0800
